{-------------------------------------------------------------------------------
unit jkXMLTools
Version 1.0
(c) 2000 by Jan W. Krieger

Diese Unit stellt einige Tool-Funktionen zum Interpretieren von XML-Dokumenten
bereit.

--------------------------------------------------------------------------------}

unit jkXMLTools;

interface

uses classes, jktools;

const
  xmlError : Array[0..4] of string =
  ('FEHLER 0: kein Fehler aufgetreten',
   'FEHLER 1: XML-Tag ist ungltig: SPACES zwischen "<", bzw. "</" und Tag-Name',
   'FEHLER 2: XML-Tag endet nicht mit ">"',
   'FEHLER 3: XML-Tag ist zugleich leer und End-Tag',
   'FEHLER 4: XML-Tag enthlt "=", ohne vorherigen Parameternamen');

  xmlSpaces = [#32, #9, #10, #13]; //XML-SPACE-Zeichen
  // Leerzeichen, Tabulator, LineFeed, CarriageReturn

  xmlNames = ['0'..'9', 'a'..'z', 'A'..'Z', '!', '?', ':', '.', '_', '-']; // gltige Zeichen fr XML-Tag-Namen

  xmlValueStart = ['''', '"']; //gltige Zeichen, die einen Parameter-Wert umschlieen


function jkXMLInterpretTag(tagtext:string; var tagname:string; var isendtag, isemptytag:boolean; var tagParams:TStrings):word;
// lst einen XML-Tag in seine "Elemente" auf --> tagname, Parameter, handelt es sich um einen Abschlusstag


implementation

function jkXMLInterpretTag(tagtext:string; var tagname:string; var isendtag, isemptytag:boolean; var tagParams:TStrings):word;
var tag, ValueStartChar, paramTmp, valueTmp, ParamText : ansistring;
    isParamName, isParamValue, isTagName : boolean;
    i, taglen:longint;
    errorcode:Word;
begin
  //Initialisierung aller Parameter
  tagParams.Clear;
  tagname           := '';
  isEndTag          := false;
  isEmptyTag        := false;
  tag               := delrspace(tagtext);
  taglen            := length(tag);
  isParamName       := false;
  isParamValue      := false;
  errorcode         := 0;
  ValueStartChar    := '';
  paramTmp          := '';
  valueTmp          :='';
  ParamText         := '';

  // Suche nach einleitendem "<", oder "</"  --> Bestimmung, ob Endtag, oder leerer Tag,
  // Bestimmen weiterer formaler Fehler
  if (tag[1]+tag[2]='</') then begin
    isEndTag:=true;  // der wird durch "</" eingeleitet
                     // ==> es handelt sich um Endtag
  end;
  if (tag[taglen-1]+tag[taglen]='/>') then
    isEmptyTag:=true;  // der Tag wird durch "/>" abgeschlossen
                       // ==> es handelt sich um einen leeren Tag
  if isEndTag and isEmptyTag then errorcode:=3;
  if tag[taglen]<>'>' then errorcode:=2;

  // Falls keine Fehler aufgetreten sind verarbeiten des Textes
  if errorcode=0 then begin
    // Tagumklammerung entfernen
    if isEndTag then tag:=copy(tag,3,taglen-2) else tag:=copy(tag,2,taglen-1);
    taglen:=length(tag);
    if isEmptyTag then tag:=copy(tag,1,taglen-2) else tag:=copy(tag,1,taglen-1);
    tag:=delRSpace(tag);
    taglen:=length(tag);
    //tagParams.Add(tag);  // Testausgabe

    // Tag interpretieren
    istagName:=true; // zuerst nach Zagnamen suchen
    i:=1;
    repeat
      if (isTagName and (tag[i]='=')) then errorcode:=4;
      if isTagName and (tag[i] in xmlNames) then tagname:=tagName+tag[i];
      if isTagName and (not(tag[i] in xmlNames)) then begin
        isTagName:=false;
        ParamTmp:='';
        repeat   // nach dem Anfang des Parameternamens suchen
          inc(i);
        until (tag[i] in xmlnames)or(i=taglen);
        if i<taglen then begin isParamName:=true; end;
      end;
      if isParamName and (tag[i] in xmlNames) then paramtmp:=paramtmp+tag[i];
      if isParamName and (tag[i] in ['=']+xmlSpaces) then begin
        isParamName:=false;
        tagParams.add(Paramtmp);
        ParamTmp:='';
        repeat   // nach dem Anfang des Parameterwertes suchen
          inc(i);
        until (tag[i] in xmlValueStart)or(i=taglen);
        if i<taglen then begin isParamValue:=true; inc(i); end;
      end;
      if isParamValue and (not(tag[i] in xmlValueStart)) then valuetmp:=valuetmp+tag[i];
      if isParamValue and (tag[i] in xmlValueStart) then begin
        isParamValue:=false;
        tagParams.Add(valuetmp);
        valuetmp:='';
        repeat   // nach dem Anfang des Parameternamens suchen
          inc(i);
        until (tag[i] in xmlnames)or(i=taglen);
        if i<taglen then begin isParamName:=true; dec(i) end;
      end;

      inc(i);
    until i>taglen;
  end;

//  tagParams.Add(#13#10+xmlError[errorcode]);  //Testausgabe des Fehler-Statuses
  result:=errorcode;
end;

end.
